## stlcmd 1.0

=== Makefile ===
prefix?=/usr/local
target=$(DESTDIR)$(prefix)

VERSION=1.0
DOCS_DIR := man
BIN_DIR := bin
CMDS := $(addprefix $(BIN_DIR)/,stl_header stl_merge stl_transform stl_count stl_bbox stl_cube stl_sphere stl_cylinder stl_cone stl_torus stl_empty stl_threads stl_normals stl_convex stl_borders stl_spreadsheet)

CC := g++
#FLAGS=-Og -g -std=c++11
FLAGS=-O3 -std=c++11

all: $(CMDS) bin/stl_boolean

$(BIN_DIR)/%: src/%.cpp src/stl_util.h
	$(CC) $(FLAGS) $(CPPFLAGS) $(CFLAGS) $(CXXFLAGS) $(LDFLAGS) $(OUTPUT_OPTION) $<

$(BIN_DIR)/stl_boolean: src/stl_boolean.cpp src/csgjs/*.cpp src/csgjs/math/*.cpp src/csgjs/math/*.h src/csgjs/*.h
	$(CC) $(FLAGS) $(CPPFLAGS) $(CFLAGS) $(CXXFLAGS) $(LDFLAGS) src/stl_boolean.cpp src/csgjs/*.cpp src/csgjs/math/*.cpp -Isrc -o bin/stl_boolean 

$(CMDS): | $(BIN_DIR)

$(BIN_DIR):
	mkdir $(BIN_DIR)

clean:
	rm -rf $(BIN_DIR)

$(DOCS_DIR):
	mkdir $(DOCS_DIR)

docs: $(DOCS_DIR) $(CMDS)
	for cmd in $(CMDS); do \
	  help2man $$cmd --name="$$($$cmd --help 2>&1 | head --lines=1)" --no-discard-stderr --version-string="v$(VERSION)" --no-info > $(DOCS_DIR)/$$(basename $$cmd).1; \
	done

installDocs: docs
	install -d $(target)/share/man/man1
	for cmd in $(CMDS); do \
	  gzip -c -9 $(DOCS_DIR)/$$(basename $$cmd).1 > $(target)/share/man/man1/$$(basename $$cmd).1.gz; \
	done

uninstallDocs:
	for cmd in $(CMDS); do \
	  rm $(target)/share/man/man1/$$(basename $$cmd).1.gz; \
	done

install: all
	install -d $(target)/bin
	for cmd in $(CMDS); do \
	  install $$cmd $(target)/$$cmd; \
	done

uninstall: 
	for cmd in $(CMDS); do \
	  rm $(target)/$$cmd; \
	done

## stlcmd 1.1

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,13 @@
 prefix?=/usr/local
 target=$(DESTDIR)$(prefix)
 
-VERSION=1.0
+VERSION=1.1
 DOCS_DIR := man
 BIN_DIR := bin
 CMDS := $(addprefix $(BIN_DIR)/,stl_header stl_merge stl_transform stl_count stl_bbox stl_cube stl_sphere stl_cylinder stl_cone stl_torus stl_empty stl_threads stl_normals stl_convex stl_borders stl_spreadsheet)
+CSGJS_CMDS := $(addprefix $(BIN_DIR)/,stl_boolean)
+
+ALL_CMDS := $(CSGJS_CMDS) $(CMDS)
 
 CC := g++
 #FLAGS=-Og -g -std=c++11
@@ -30,28 +33,28 @@
 	mkdir $(DOCS_DIR)
 
 docs: $(DOCS_DIR) $(CMDS)
-	for cmd in $(CMDS); do \
+	for cmd in $(ALL_CMDS); do \
 	  help2man $$cmd --name="$$($$cmd --help 2>&1 | head --lines=1)" --no-discard-stderr --version-string="v$(VERSION)" --no-info > $(DOCS_DIR)/$$(basename $$cmd).1; \
 	done
 
 installDocs: docs
 	install -d $(target)/share/man/man1
-	for cmd in $(CMDS); do \
+	for cmd in $(ALL_CMDS); do \
 	  gzip -c -9 $(DOCS_DIR)/$$(basename $$cmd).1 > $(target)/share/man/man1/$$(basename $$cmd).1.gz; \
 	done
 
 uninstallDocs:
-	for cmd in $(CMDS); do \
+	for cmd in $(ALL_CMDS); do \
 	  rm $(target)/share/man/man1/$$(basename $$cmd).1.gz; \
 	done
 
 install: all
 	install -d $(target)/bin
-	for cmd in $(CMDS); do \
+	for cmd in $(ALL_CMDS); do \
 	  install $$cmd $(target)/$$cmd; \
 	done
 
 uninstall: 
-	for cmd in $(CMDS); do \
+	for cmd in $(ALL_CMDS); do \
 	  rm $(target)/$$cmd; \
 	done

=== debian/changelog ===
stlcmd (1.1-1) unstable; urgency=medium

  * Fixed Makefile to properly install stl_boolean. (Closes: #885792)

 -- John Allwine <john@allwinedesigns.com>  Sat, 30 Dec 2017 04:13:36 +0000

stlcmd (1.0-1) unstable; urgency=low

  * Initial release. (Closes: #884310)

 -- John Allwine <john@allwinedesigns.com>  Sun, 17 Dec 2017 20:57:31 +0000

=== debian/control ===
Source: stlcmd
Maintainer: John Allwine <john@allwinedesigns.com>
Homepage: https://www.github.com/AllwineDesigns/stl_cmd
Section: misc
Priority: optional
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 10), help2man

Package: stlcmd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Suite of commands for generating, inspecting and manipulating STL files
 stl_cmd is a suite of command line tools for generating, inspecting and
 manipulating STL files which are often used in 3D printing. The goal of this 
 project is to be a resource for teaching terminal usage and some basic 
 programming concepts in the 3D printing space. Imagine an assignment which 
 involves building a brick wall. Students would need to use a combination of 
 stl_cube, stl_transform and stl_merge. The commands could be combined in a 
 bash or <insert favorite scripting language> script with for and while 
 loops, could accept input and use conditionals to affect the attributes of 
 the wall.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

ifeq ($(origin CC),default)
CC := $(DEB_HOST_GNU_TYPE)-g++
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_build:
	$(MAKE) CC=$(CC)
	$(MAKE) docs

override_dh_auto_install:
	$(MAKE) DESTDIR=$$(pwd)/debian/stlcmd prefix=/usr install
	$(MAKE) DESTDIR=$$(pwd)/debian/stlcmd prefix=/usr installDocs
	mkdir -p $$(pwd)/debian/stlcmd/usr/share/doc/stlcmd
	gzip -n -c -9 CHANGES > $$(pwd)/debian/stlcmd/usr/share/doc/stlcmd/changelog.gz

## stlcmd 1.2

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,11 @@
 prefix?=/usr/local
 target=$(DESTDIR)$(prefix)
 
-VERSION=1.1
+VERSION=1.2
 DOCS_DIR := man
 BIN_DIR := bin
-CMDS := $(addprefix $(BIN_DIR)/,stl_header stl_merge stl_transform stl_count stl_bbox stl_cube stl_sphere stl_cylinder stl_cone stl_torus stl_empty stl_threads stl_normals stl_convex stl_borders stl_spreadsheet)
-CSGJS_CMDS := $(addprefix $(BIN_DIR)/,stl_boolean)
+CMDS := $(addprefix $(BIN_DIR)/,stl_header stl_merge stl_transform stl_count stl_bbox stl_cube stl_sphere stl_cylinder stl_cylinders stl_cone stl_torus stl_empty stl_threads stl_normals stl_convex stl_borders stl_spreadsheet stl_area stl_volume stl_bcylinder stl_binary stl_ascii stl_zero)
+CSGJS_CMDS := $(addprefix $(BIN_DIR)/,stl_boolean stl_flat stl_decimate)
 
 ALL_CMDS := $(CSGJS_CMDS) $(CMDS)
 
@@ -13,13 +13,13 @@
 #FLAGS=-Og -g -std=c++11
 FLAGS=-O3 -std=c++11
 
-all: $(CMDS) bin/stl_boolean
+all: $(CMDS) $(CSGJS_CMDS)
 
-$(BIN_DIR)/%: src/%.cpp src/stl_util.h
+$(CMDS): $(BIN_DIR)/%: src/%.cpp src/stl_util.h
 	$(CC) $(FLAGS) $(CPPFLAGS) $(CFLAGS) $(CXXFLAGS) $(LDFLAGS) $(OUTPUT_OPTION) $<
 
-$(BIN_DIR)/stl_boolean: src/stl_boolean.cpp src/csgjs/*.cpp src/csgjs/math/*.cpp src/csgjs/math/*.h src/csgjs/*.h
-	$(CC) $(FLAGS) $(CPPFLAGS) $(CFLAGS) $(CXXFLAGS) $(LDFLAGS) src/stl_boolean.cpp src/csgjs/*.cpp src/csgjs/math/*.cpp -Isrc -o bin/stl_boolean 
+$(CSGJS_CMDS): $(BIN_DIR)/%: src/%.cpp src/csgjs/*.cpp src/csgjs/math/*.cpp src/csgjs/math/*.h src/csgjs/*.h src/Simplify.h
+	$(CC) $(FLAGS) $(CPPFLAGS) $(CFLAGS) $(CXXFLAGS) $(LDFLAGS) src/csgjs/*.cpp src/csgjs/math/*.cpp -Isrc $(OUTPUT_OPTION) $< 
 
 $(CMDS): | $(BIN_DIR)

=== debian/changelog ===
stlcmd (1.2-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
    Closes: #1087049
  * Maintain package in Debian 3-D Printing Packages team
    Closes: #1107310
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * d/copyright: review
  * Fix clean target
    Closes: #1048618

  [ наб ]
  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Wed, 04 Jun 2025 22:06:28 +0200

=== debian/control ===
Source: stlcmd
Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders: John Allwine <john@allwinedesigns.com>
Homepage: https://www.github.com/AllwineDesigns/stl_cmd
Section: misc
Priority: optional
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), help2man
Vcs-Browser: https://salsa.debian.org/3dprinting-team/stlcmd
Vcs-Git: https://salsa.debian.org/3dprinting-team/stlcmd.git

Package: stlcmd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Suite of commands for generating, inspecting and manipulating STL files
 stl_cmd is a suite of command line tools for generating, inspecting and
 manipulating STL files which are often used in 3D printing. The goal of this
 project is to be a resource for teaching terminal usage and some basic
 programming concepts in the 3D printing space. Imagine an assignment which
 involves building a brick wall. Students would need to use a combination of
 stl_cube, stl_transform and stl_merge. The commands could be combined in a
 bash or <insert favorite scripting language> script with for and while
 loops, could accept input and use conditionals to affect the attributes of
 the wall.

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,10 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+override_dh_clean:
+	dh_clean
+	rm -rf man
+
 override_dh_auto_build:
 	$(MAKE) CC=$(CC)
 	$(MAKE) docs

=== debian/watch ===
version=4

opts=\
pgpmode=self,\
filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz.asc%,\
downloadurlmangle=s%api.github.com/repos/([^/]+/[^/]+)/git/refs/tags/@ANY_VERSION@%github.com/$1/releases/download/v$2/stl_cmd-$2.tar.gz.asc%g,\
searchmode=plain \
 https://api.github.com/repos/AllwineDesigns/stl_cmd/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
